<script type="ts">
    import { color_schemes } from "../../option_constants/color_schemes.js";
    import * as d3 from "d3";

    export let plot_element;
    // export let xScale;
    export let x_coordinate = 100;
    export let y_coordinate_bar = 120;
    export let barWidth = 160;
    export let barHeight = 8;
    export let ticks = barWidth / 64;

    $: left = x_coordinate;
    $: right = x_coordinate + barWidth;

    $: color_scale = d3.scaleSequential(
        [
            plot_element.plot_options.color_map_domain.trim[0],
            plot_element.plot_options.color_map_domain.trim[1],
        ],
        color_schemes[plot_element.plot_options.color_map],
    );
    let type = "continuous";
    $: x = Object.assign(
        color_scale.copy().interpolator(d3.interpolateRound(left, right)),
        {
            range() {
                return [left, right];
            },
        },
    );

    $: n = Math.min(color_scale.domain().length, color_scale.range().length);

    const color_ramp = function (color_scale, n = 256, reverse) {
        const canvas = document.createElement("canvas");
        canvas.width = n;
        canvas.height = 1;
        const context = canvas.getContext("2d");
        for (let i = 0; i < n; ++i) {
            if (reverse) {
                context.fillStyle = color_scale(1 - i / (n - 1));
            } else {
                context.fillStyle = color_scale(i / (n - 1));
            }
            context.fillRect(i, 0, 1, 1);
        }
        return canvas;
    };
</script>

{#if type == "continuous"}
    <image
        x={left}
        y={y_coordinate_bar + 1.5 * barHeight}
        width={barWidth}
        height={barHeight}
        preserveAspectRatio="none"
        xlink:href={color_ramp(
            color_scale.copy().domain(d3.quantize(d3.interpolate(0, 1), n)),
            256,
            plot_element.plot_options.reverse_color_map,
        ).toDataURL()} />
{/if}
{#each x.ticks(ticks) as tick}
    <line
        x1={x(tick)}
        x2={x(tick)}
        y1={y_coordinate_bar + 1.5 * barHeight}
        y2={y_coordinate_bar + 2.5 * barHeight}
        stroke-width="1px"
        class="stroke-black dark:stroke-white" />
    <text
        x={x(tick)}
        y={y_coordinate_bar + 2.5 * barHeight + 12}
        font-family="-apple-system, 'Helvetica Neue', sans-serif"
        font-size="11px"
        text-anchor="middle"
        class="fill-black dark:fill-white">{tick}</text>
{/each}
